routes/web.php
<?php

use Illuminate\Support\Facades\Route;

Route::group([
    'as' => 'web.tasks.',
    'prefix' => 'tasks',
    'middleware' => 'auth'
], function () {
    Route::get('/', 'TaskController@index')->name('index');
    Route::get('/create', 'TaskController@create')->name('create');
//    Route::view('/create', 'tasks.create')->name('create'); // if return only view
    Route::post('/', 'TaskController@store')->name('store');
    Route::delete('/{task}', 'TaskController@destroy')->name('destroy');
});

Route::get('/', function () {
    return view('welcome');
});

Route::middleware(['auth:sanctum', 'verified'])->get('/dashboard', function () {
    return view('dashboard');
})->name('dashboard');

app/Models/Task.php
<?php

namespace App\Models;

use App\Http\Resources\UserResource;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Http\Request;
use Illuminate\Support\Carbon;

class Task extends Model
{
    use HasFactory;

    protected $fillable = [
        'title',
        'description',
        'is_done',
        'user_id',
        'created_by'
    ];

//    protected $append = [
//        'user'
//    ];

    protected $hidden = [
        'created_by',
        'user_id',
    ];

    protected $casts = [
        'is_done' => 'boolean',
        'created_at' => 'timestamp'
    ];

    public function user()
    {
//        return $this->belongsTo('App\Models\User', 'user_id');
        return $this->belongsTo(User::class);
    }

    public function creator()
    {
        return $this->belongsTo(User::class, 'created_by');
    }

    public function getCreatedAtAttribute()
    {
        return Carbon::create($this->attributes['created_at'])->timestamp;
    }

    public function getUpdatedAtAttribute()
    {
        return Carbon::create($this->attributes['updated_at'])->timestamp;
    }


//    public function getUserAttribute()
//    {
//        return $this->user()->first();
//    }
    public function toArray()
    {
        return [
            'id' => $this->id,
            'title' => $this->title,
            'body' => $this->description,
            'user' => $this->user? new UserResource($this->user) : null
        ];
    }

//    public function toArray()
//    {
//        return [
//            'id' => $this->id,
//            'title' => $this->title,
//            'body' => $this->description,
//            'user' => $this->user/*? [
//                'id' => $this->user->id,
//                'name' => $this->user->name,
//            ] : null,*/
//        ];
//    }
}

app/Http/Controllers/API/TaskController.php
<?php

namespace App\Http\Controllers\API;

use AElnemr\RestFullResponse\CoreJsonResponse;
use App\Http\Controllers\Controller;
use App\Http\Requests\TaskRequest;
use App\Http\Resources\TaskListResource;
use App\Http\Resources\TaskShowResource;
use App\Repository\TaskRepositoryInterface;
use Illuminate\Http\Request;

class TaskController extends Controller
{
    /**
     * @var TaskRepositoryInterface
     */
    private $taskRepository;

    public function __construct(TaskRepositoryInterface $taskRepository)
    {
        $this->taskRepository = $taskRepository;
    }

    public function index(Request $request)
    {
        $allTasks = $this->taskRepository->paginate(5, $request);
        return $this->okWithPagination(TaskListResource::collection($allTasks));
    }


    public function store(TaskRequest $request)
    {
//        $this->auth($request);
        $task = $this->taskRepository->create($request);
        return $this->created((new TaskShowResource($task))->resolve());
    }

    // we should use middleware
//    public function auth(Request $request)
//    {
//        if ($request->query('token') !== '12345') {
//            return $this->unauthorized();
//        }
//    }
}

app/Http/Controllers/TaskController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\TaskRequest;
use App\Models\Task;
use App\Repository\Eloquent\TaskRepository;
use App\Repository\TaskRepositoryInterface;
use App\Repository\UserRepositoryInterface;
use Illuminate\Http\Request;

class TaskController extends Controller
{

    /**
     * @var TaskRepositoryInterface
     */
    private $taskRepository;
    /**
     * @var UserRepositoryInterface
     */
    private $userRepository;

    public function __construct(TaskRepositoryInterface $taskRepository, UserRepositoryInterface $userRepository)
    {
        $this->taskRepository = $taskRepository;
        $this->userRepository = $userRepository;
    }

    public function index(Request $request)
    {
        return view('tasks.index', [
            'tasks' => $this->taskRepository->paginate(5, $request)
        ]);
    }

    public function create()
    {
        $users = $this->userRepository->limit(5)->get();
//        return view('tasks.create', compact('users'));
        return view('tasks.create')->with('users', $users);
    }

    public function store(TaskRequest $request)
    {
        $this->taskRepository->create($request);
        return redirect(route('web.tasks.index'));
    }

    public function destroy(Task $task)
    {
        $task->delete();
        return redirect(route('web.tasks.index'));
    }
}

resources/views/tasks/_form.blade.php
@csrf
<div class="form-group">
    <label for="title">Title</label>
    <input type="text" id="title" name="title" class="form-control" value="{{old('title')}}">
    @error('title')
    <p class="alert alert-danger">{{ $message }}</p>
    @enderror
</div>
<br>
<div class="form-group">
    <label for="is_done">is done</label>
    <input type="checkbox" name="is_done" id="is_done" value="1" {{old('is_done')? 'checked' : ''}}>
    @error('is_done')
    <p class="alert alert-danger">{{ $message }}</p>
    @enderror
</div>
<br>
<div class="form-group">
    <label for="user_id">User</label>
    <select name="user_id" id="user_id" class="form-control">
        <option value>select user</option>
        @foreach($users as $user)
            <option value="{{$user->id}}" {{old('user_id') == $user->id ? 'selected' : ''}}>
                {{$user->name}}
            </option>
        @endforeach
    </select>
    @error('user_id')
    <p class="alert alert-danger">{{ $message }}</p>
    @enderror
</div>
<br>
<div class="form-group">
    <label for="description">description</label>
    <textarea name="description" id="description" class="form-control" cols="30"
              rows="10">{{old('description')}}</textarea>
    @error('is_done')
    <p class="alert alert-danger">{{ $message }}</p>
    @enderror
</div>

<div class="text-center mt-5">
    <button class="btn btn-success">Save</button>
</div>

resources/views/tasks/create.blade.php
@extends('layouts.app')

@section('title', 'Create new Task')

@section('content')
    <h1>Create new Task</h1>
    <form action="{{ route('web.tasks.store') }}" method="post">
        @include('tasks._form')
    </form>
@endsection

resources/views/tasks/index.blade.php
@extends('layouts.app')

@section('title', 'All Tasks')

@section('content')
    <h1>Tasks</h1>
    <a href="{{ route('web.tasks.create') }}" class="btn btn-primary">Add New Task</a>
    <ul>
        @foreach($tasks as $task)
            <li class="m-3">
                {{ $task->title }} |
                @include('components.form.buttons.delete', ['url' => route('web.tasks.destroy', $task)])
            </li>
        @endforeach
    </ul>
@endsection